<?php
namespace HCM\AVL\Repository;

use Doctrine\ORM\EntityManager;

class QuestionarioRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */

    public function constroiObjeto($dados) {
        $query = $this->entityManager->getConnection()->prepare("
            SELECT 'QUESTAO_'||RESPOSTA.NRQUESTAO QUESTAO, 
                RESPAVALIACAO.NRRESPOSTA RESPOSTA
                  FROM EXECAVALIACAO
                  INNER JOIN RESPOSTA
                    ON RESPOSTA.NRQUESTAO = EXECAVALIACAO.NRQUESTAO
                    AND RESPOSTA.NRORG = EXECAVALIACAO.NRORG
                  INNER JOIN RESPAVALIACAO
                    ON RESPAVALIACAO.NRRESPOSTA = RESPOSTA.NRRESPOSTA
                    AND RESPAVALIACAO.NRORG = RESPOSTA.NRORG
        AND RESPAVALIACAO.NREXECAVALIACAO = EXECAVALIACAO.NREXECAVALIACAO
        AND RESPAVALIACAO.NRORG           = EXECAVALIACAO.NRORG
                  WHERE EXECAVALIACAO.NRORG          = :P_NRORG
                    AND EXECAVALIACAO.NRAVALIACAO    = :P_NRAVALIACAO
                    AND EXECAVALIACAO.NRPARCAVALIADO = :P_NRPARCAVALIADO
                    AND EXECAVALIACAO.NRPARCEXECAVAL = :P_NRPARCEXECAVAL"
        );

        $query->execute(
            array(
                "P_NRPARCAVALIADO" => $dados["NRPARCAVALIADO"],
                "P_NRPARCEXECAVAL" => $dados["NRPARCEXECAVAL"],
                "P_NRAVALIACAO"    => $dados["NRAVALIACAO"],
                "P_NRORG"          => $dados["NRORG"]
            )
        );
        return $query->fetchAll();
    }

    public function enviar($nravaliacao, $nrparcexecaval, $nrparcavaliado, $nrcombquestaval, $nrorg, $dataAtual){
        $query = $this->entityManager->getConnection()->prepare("
                UPDATE PARTICIPAVAL 
                  SET IDSITUACAOAVAL    = 'CONCLUIDA',
                    DTCONCLUSAOAVAL     = TO_DATE(:P_DATAATUAL, 'DD/MM/YYYY HH24:MI:SS')
                  WHERE NRAVALIACAO     = :P_NRAVALIACAO
                    AND NRPARCEXECAVAL  = :P_NRPARCEXECAVAL
                    AND NRPARCAVALIADO  = :P_NRPARCAVALIADO
                    AND NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL
                    AND NRORG           = :P_NRORG");

        return $query->execute(
          array(
            "P_DATAATUAL"       => $dataAtual,
            "P_NRPARCAVALIADO"  => $nrparcavaliado,
            "P_NRPARCEXECAVAL"  => $nrparcexecaval,
            "P_NRAVALIACAO"     => $nravaliacao,
            "P_NRCOMBQUESTAVAL" => $nrcombquestaval,
            "P_NRORG"           => $nrorg
          )
        );
    }

    public function getAlternativasQuestoes($nrquestao, $nrorg) {
        $query = $this->entityManager->getConnection()->prepare("
            SELECT DSRESPOSTA, NRRESPOSTA, VRPESORESPOSTA, NRORDENARESPOST
                  FROM RESPOSTA
                  WHERE NRQUESTAO = :P_NRQUESTAO
                    AND NRORG     = :P_NRORG"
        );

        $query->execute(
          array(
            "P_NRQUESTAO" => $nrquestao,
            "P_NRORG"     => $nrorg
          )
        );

        return $query->fetchAll();
    }

    public function getCabecalhoQuestionario($nravaliacao, $nrorg) {
        $query = $this->entityManager->getConnection()->prepare("
                SELECT AVALIACAOGERAL.NMAVALIACAO
                  FROM AVALIACAOGERAL
                  WHERE NRAVALIACAO = :P_NRAVALIACAO
                  AND NRORG         = :P_NRORG"
        );

        $query->execute(
            array(
                "P_NRAVALIACAO" => $nravaliacao,
                "P_NRORG"     => $nrorg
            )
        );
        return $query->fetchAll()[0];
    }

    public function getExecaval($nrcombquestaval, $nrparcavaliado, $nravaliacao, $nrquestao, $nrparcexecaval, $nrorg) {
        $query = $this->entityManager->getConnection()->prepare("
            SELECT NREXECAVALIACAO
                  FROM EXECAVALIACAO
                  WHERE (NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL OR :P_NRCOMBQUESTAVAL IS NULL)
                    AND NRPARCAVALIADO  = :P_NRPARCAVALIADO
                    AND NRAVALIACAO     = :P_NRAVALIACAO
                    AND NRQUESTAO       = :P_NRQUESTAO
                    AND NRPARCEXECAVAL  = :P_NRPARCEXECAVAL
                    AND NRORG           = :P_NRORG");

        $query->execute(
          array(
              "P_NRPARCAVALIADO"  => $nrparcavaliado,
              "P_NRPARCEXECAVAL"  => $nrparcexecaval,
              "P_NRAVALIACAO"     => $nravaliacao,
              "P_NRQUESTAO"       => $nrquestao,
              "P_NRCOMBQUESTAVAL" => $nrcombquestaval,
              "P_NRORG"           => $nrorg
            )
        );

        return $query->fetchAll()[0];
        //$nrexecavaliacao = $result['NREXECAVALIACAO'];
    }

    public function getExecavaliacao($nravaliacao, $nrorg, $nrparnegocio) {
      $query = $this->entityManager->getConnection()->prepare("
            SELECT AVALIACAOGERAL.NRAVALIACAO,
                  QUESTAVALIACAO.NRQUESTAO,
                  QUESTAVALIACAO.NRCOMBQUESTAVAL,
                  PARTICIPAVAL.NRPARCAVALIADO,
                  PARTICIPAVAL.NRPARCEXECAVAL
              FROM QUESTAVALIACAO,
                  AVALIACAOGERAL,
                  COMBQUESTAVAL,
                  QUESTAO,
                  PARTICIPAVAL
             WHERE QUESTAO.NRQUESTAO             = QUESTAVALIACAO.NRQUESTAO
               AND COMBQUESTAVAL.NRCOMBQUESTAVAL = QUESTAVALIACAO.NRCOMBQUESTAVAL
               AND (COMBQUESTAVAL.NRAVALIACAO    = AVALIACAOGERAL.NRAVALIACAO
                OR COMBQUESTAVAL.NRAVALIACAO     IS NULL)
               AND PARTICIPAVAL.NRCOMBQUESTAVAL  = COMBQUESTAVAL.NRCOMBQUESTAVAL
               AND AVALIACAOGERAL.NRAVALIACAO    = PARTICIPAVAL.NRAVALIACAO
               AND AVALIACAOGERAL.NRAVALIACAO    = QUESTAVALIACAO.NRAVALIACAO
               AND AVALIACAOGERAL.NRORG          = QUESTAVALIACAO.NRORG
               AND COMBQUESTAVAL.NRORG           = QUESTAVALIACAO.NRORG
               AND QUESTAO.NRORG                 = QUESTAVALIACAO.NRORG
               AND PARTICIPAVAL.NRORG            = QUESTAVALIACAO.NRORG
               AND AVALIACAOGERAL.NRAVALIACAO    = :P_NRAVALIACAO
               AND QUESTAVALIACAO.NRORG          = :P_NRORG
               AND PARTICIPAVAL.NRPARCAVALIADO   = :P_NRPARNEGOCIO
               AND NOT EXISTS
                  (SELECT EXECAVALIACAO.NRPARCAVALIADO,
                    EXECAVALIACAO.NRPARCEXECAVAL,
                    EXECAVALIACAO.NRCOMBQUESTAVAL,
                    EXECAVALIACAO.NRAVALIACAO
                     FROM EXECAVALIACAO
                    WHERE PARTICIPAVAL.NRPARCAVALIADO   = EXECAVALIACAO.NRPARCAVALIADO
                      AND PARTICIPAVAL.NRPARCEXECAVAL   = EXECAVALIACAO.NRPARCEXECAVAL
                      AND QUESTAO.NRQUESTAO             = EXECAVALIACAO.NRQUESTAO
                      AND PARTICIPAVAL.NRCOMBQUESTAVAL  = EXECAVALIACAO.NRCOMBQUESTAVAL
                      AND PARTICIPAVAL.NRORG            = EXECAVALIACAO.NRORG
                      AND PARTICIPAVAL.NRAVALIACAO      = EXECAVALIACAO.NRAVALIACAO)"
      );

      $query->execute(
        array(
            "P_NRAVALIACAO"  => $nravaliacao,
            "P_NRORG"        => $nrorg,
            "P_NRPARNEGOCIO" => $nrparnegocio
        )
      );
      return $query->fetchAll();
    }

    public function getQuestoes($nravaliacao, $nrorg, $nravaliador, $nravaliado) {
        $query = $this->entityManager->getConnection()->prepare("
                SELECT QUESTAO.NRQUESTAO,
                  AVALIACAOGERAL.NRAVALIACAO,
                  AGRUPQUESTAVAL.NMAGRUPQUESTAVA,
                  QUESTAO.TXQUESTAO,
                  'QUESTAO_'||QUESTAO.NRQUESTAO \"QUESTION_NAME\",
                  'false' \"QUESTION_ALTERNATIVE_OPTION\",
                  DECODE(QUESTAO.IDQUESTAOOBRIGA, 'S', 'true', 'false') \"QUESTAO_REQUIRED\",
                  QUESTAVALIACAO.NRORDEQUESTAVAL
                FROM QUESTAVALIACAO,
                  QUESTAO,
                  COMBQUESTAVAL,
                  EXECAVALIACAO,
                  AVALIACAOGERAL,
                  AGRUPQUESTAVAL
                WHERE QUESTAVALIACAO.NRQUESTAO     = QUESTAO.NRQUESTAO
                AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = QUESTAVALIACAO.NRCOMBQUESTAVAL
                AND COMBQUESTAVAL.NRORG            = EXECAVALIACAO.NRORG
                AND QUESTAO.NRQUESTAO              = EXECAVALIACAO.NRQUESTAO
                AND QUESTAO.NRORG                  = EXECAVALIACAO.NRORG
                AND EXECAVALIACAO.NRCOMBQUESTAVAL  = COMBQUESTAVAL.NRCOMBQUESTAVAL
                AND QUESTAO.NRQUESTAO              = QUESTAVALIACAO.NRQUESTAO
                AND QUESTAVALIACAO.NRAGRUPQUESTAVA = AGRUPQUESTAVAL.NRAGRUPQUESTAVA(+)
                AND QUESTAVALIACAO.NRORG           = EXECAVALIACAO.NRORG
                AND AVALIACAOGERAL.NRAVALIACAO     = EXECAVALIACAO.NRAVALIACAO
                AND AVALIACAOGERAL.NRORG           = EXECAVALIACAO.NRORG
                AND EXECAVALIACAO.NRPARCAVALIADO   = :P_NRPARCAVALIADO
                AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                AND EXECAVALIACAO.NRPARCEXECAVAL   = :P_NRPARCEXECAVAL
                AND EXECAVALIACAO.NRORG            = :P_NRORG
                ORDER BY NRORDEQUESTAVAL"
        );

        $query->execute(
            array(
                "P_NRPARCAVALIADO" => $nravaliado,
                "P_NRPARCEXECAVAL" => $nravaliador,
                "P_NRAVALIACAO"    => $nravaliacao,
                "P_NRORG"          => $nrorg
            )
        );
        return $query->fetchAll();
    }

    public function getRespAvaliacao($nrexecavaliacao, $nrorg) {
      
        $query = $this->entityManager->getConnection()->prepare("
                SELECT NRRESPAVALIACAO
                     FROM RESPAVALIACAO
                     WHERE NREXECAVALIACAO = :P_NREXECAVALIACAO
                     AND NRORG = :P_NRORG"
        );
        $query->execute(
          array(
              "P_NREXECAVALIACAO"  => $nrexecavaliacao,
              "P_NRORG"            => $nrorg
          )
        );
        
        if(empty($query->fetchAll()) || $query->fetchAll() == []){
          return false;
        } else {
          return $query->fetchAll()[0];
        }

    }

    public function getResposta($resposta, $nrorg) {
        $query = $this->entityManager->getConnection()->prepare("
              SELECT DSRESPOSTA
                         FROM RESPOSTA
                         WHERE NRRESPOSTA = :P_RESPOSTA
                         AND NRORG = :P_NRORG");

        $query->execute(
          array(
              "P_RESPOSTA"    => $resposta,
              "P_NRORG"       => $nrorg
          )
        );
        if(empty($query->fetchAll()) || $query->fetchAll() == []){
          return false;
        } else {
          return $query->fetchAll()[0];
        }
    }

    public function insertExecavaliacao($dataSet) {
      $query = $this->entityManager->getConnection()->prepare("
          INSERT INTO EXECAVALIACAO (          
              NREXECAVALIACAO,
              NRAVALIACAO,
              NRPARCAVALIADO,
              NRPARCEXECAVAL,
              NRQUESTAO,
              NRORG,
              NRCOMBQUESTAVAL,
              DTEXECUCAOAVAL,
              IDORIGEMEXECAVAL,
              IDATIVO,
              DTINCLUSAO,
              DTULTATU,
              NRORGINCLUSAO,
              NRORGULTATU,
              CDOPERINCLUSAO,
              CDOPERULTATU
            ) VALUES (
              :P_NREXECAVALIACAO,
              :P_NRAVALIACAO,
              :P_NRPARCAVALIADO,
              :P_NRPARCEXECAVAL,
              :P_NRQUESTAO,
              :P_NRORG,
              :P_NRCOMBQUESTAVAL,
              :P_DTEXECUCAOAVAL,
              :P_IDORIGEMEXECAVAL,
              :P_IDATIVO,
              :P_DTINCLUSAO,
              :P_DTULTATU,
              :P_NRORGINCLUSAO,
              :P_NRORGULTATU,
              :P_CDOPERINCLUSAO,
              :P_CDOPERULTATU
            )"
      );

      $query->execute(
        array(
            "P_NREXECAVALIACAO"  => $dataSet['NREXECAVALIACAO'],
            "P_NRAVALIACAO"      => $dataSet['NRAVALIACAO'],
            "P_NRPARCAVALIADO"   => $dataSet['NRPARCAVALIADO'],
            "P_NRPARCEXECAVAL"   => $dataSet['NRPARCEXECAVAL'],
            "P_NRQUESTAO"        => $dataSet['NRQUESTAO'],
            "P_NRORG"            => $dataSet['NRORG'],
            "P_NRCOMBQUESTAVAL"  => $dataSet['NRCOMBQUESTAVAL'],
            "P_DTEXECUCAOAVAL"   => $dataSet['DTEXECUCAOAVAL'],
            "P_IDORIGEMEXECAVAL" => $dataSet['IDORIGEMEXECAVAL'],
            "P_IDATIVO"          => $dataSet['IDATIVO'],
            "P_DTINCLUSAO"       => $dataSet['DATAATUAL'],
            "P_DTULTATU"         => $dataSet['DATAATUAL'],
            "P_NRORGINCLUSAO"    => $dataSet['NRORGOPERADOR'],
            "P_NRORGULTATU"      => $dataSet['NRORGOPERADOR'],
            "P_CDOPERINCLUSAO"   => $dataSet['CDOPERADOR_LOG'],
            "P_CDOPERULTATU"     => $dataSet['CDOPERADOR_LOG']
        )
      );
    }

    public function insertParticipaval($dataSet) {
      $query = $this->entityManager->getConnection()->prepare("
          INSERT INTO PARTICIPAVAL (
              NRPARTICIPAVAL,
              NRAVALIACAO,
              NRPARCAVALIADO,
              NRPARCEXECAVAL,
              NRTIPORELACIONA,
              NRORG,
              IDSITUACAOAVAL,
              NRCOMBQUESTAVAL,
              IDATIVO,
              DTINCLUSAO,
              DTULTATU,
              NRORGINCLUSAO,
              CDOPERINCLUSAO,
              NRORGULTATU,
              CDOPERULTATU
            ) VALUES (
              :P_NRPARTICIPAVAL,
              :P_NRAVALIACAO,
              :P_NRPARCAVALIADO,
              :P_NRPARCEXECAVAL,
              :P_NRTIPORELACIONA,
              :P_NRORG,
              :P_IDSITUACAOAVAL,
              :P_NRCOMBQUESTAVAL,
              :P_IDATIVO,
              :P_DTINCLUSAO,
              :P_DTULTATU,
              :P_NRORGINCLUSAO,
              :P_CDOPERINCLUSAO,
              :P_NRORGULTATU,
              :P_CDOPERULTATU
            )"
      );

      $query->execute(
        array(
            "P_NRPARTICIPAVAL"  => $dataSet['NRPARTICIPAVAL'],
            "P_NRAVALIACAO"     => $dataSet['NRAVALIACAO'],
            "P_NRPARCAVALIADO"  => $dataSet['NRPARCAVALIADO'],
            "P_NRPARCEXECAVAL"  => $dataSet['NRPARCEXECAVAL'],
            "P_NRTIPORELACIONA" => $dataSet['NRTIPORELACIONA'],
            "P_NRORG"           => $dataSet['NRORG'],
            "P_IDSITUACAOAVAL"  => $dataSet['IDSITUACAOAVAL'],
            "P_NRCOMBQUESTAVAL" => $dataSet['NRCOMBQUESTAVAL'],
            "P_DTINCLUSAO"      => $dataSet['DATAATUAL'],
            "P_DTULTATU"        => $dataSet['DATAATUAL'],
            "P_NRORGINCLUSAO"   => $dataSet['NRORGOPERADOR'],
            "P_NRORGULTATU"     => $dataSet['NRORGOPERADOR'],
            "P_CDOPERINCLUSAO"  => $dataSet['CDOPERADOR_LOG'],
            "P_CDOPERULTATU"    => $dataSet['CDOPERADOR_LOG'],
            "P_IDATIVO"         => $dataSet['IDATIVO']
        )
      );
    }

    public function insertRespavaliacao($nrrespavaliacao, $nrorg, $nrexecavaliacao, $resposta, $dsresposta, $dataAtual, $cdoperador) {
        $query = $this->entityManager->getConnection()->prepare("
            INSERT INTO RESPAVALIACAO (NRRESPAVALIACAO, NRORG, NREXECAVALIACAO, NRRESPOSTA, TXRESPAVALIACAO,
                    TXOBSCORRECAVAL, VRNOTARESPAVAL, DTINCLUSAO, DTULTATU, NRORGINCLUSAO,
                    CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO, DTRESPAVALIACAO, 
                    VRRESPAVALIACAO)
                VALUES (
                    :P_NRRESPAVALIACAO, :P_NRORG, :P_NREXECAVALIACAO, :P_RESPOSTA, :P_DSRESPOSTA,
                    '', null, TO_DATE(:P_DATAATUAL, 'DD/MM/YYYY HH24:MI:SS'), 
                    TO_DATE(:P_DATAATUAL, 'DD/MM/YYYY HH24:MI:SS'), :P_NRORG, :P_CDOPERADOR, :P_NRORG, 
                    :P_CDOPERADOR, 'S', TO_DATE(:P_DATAATUAL, 'DD/MM/YYYY HH24:MI:SS'), null
                )");

        $query->execute(
          array(
              "P_NRRESPAVALIACAO"       => $nrrespavaliacao,
              "P_NREXECAVALIACAO"  => $nrexecavaliacao,
              "P_RESPOSTA"     => $resposta,
              "P_DSRESPOSTA"  => $dsresposta,
              "P_DATAATUAL" => $dataAtual,
              "P_CDOPERADOR" => $cdoperador,
              "P_NRORG"           => $nrorg
          )
        );
    }

    public function updateExecavaliacao($dataAtual, $nravaliacao, $nrparcexecaval, $nrparcavaliado, $nrcombquestaval, $nrorg) {
        $query = $this->entityManager->getConnection()->prepare("
               UPDATE EXECAVALIACAO
                  SET DTEXECUCAOAVAL    = TO_DATE(:P_DATAATUAL, 'DD/MM/YYYY HH24:MI:SS')
                  WHERE NRAVALIACAO     = :P_NRAVALIACAO
                    AND NRPARCEXECAVAL  = :P_NRPARCEXECAVAL
                    AND NRPARCAVALIADO  = :P_NRPARCAVALIADO
                    AND NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL
                    AND NRORG           = :P_NRORG");

        return $query->execute(
          array(
              "P_DATAATUAL"       => $dataAtual,
              "P_NRPARCEXECAVAL"  => $nrparcexecaval,
              "P_NRAVALIACAO"     => $nravaliacao,
              "P_NRPARCAVALIADO"  => $nrparcavaliado,
              "P_NRCOMBQUESTAVAL" => $nrcombquestaval,
              "P_NRORG"           => $nrorg
          )
        );
    }

    public function updateParticipaval($nravaliacao, $nrparcexecaval, $nrparcavaliado, $nrcombquestaval, $nrorg) {
        $query = $this->entityManager->getConnection()->prepare("
                UPDATE PARTICIPAVAL 
                  SET IDSITUACAOAVAL    = 'ANDAMENTO' 
                  WHERE NRAVALIACAO     = :P_NRAVALIACAO
                    AND NRPARCEXECAVAL  = :P_NRPARCEXECAVAL
                    AND NRPARCAVALIADO  = :P_NRPARCAVALIADO
                    AND NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL
                    AND NRORG           = :P_NRORG");

        return $query->execute(
          array(
                "P_NRPARCEXECAVAL"  => $nrparcexecaval,
                "P_NRAVALIACAO"     => $nravaliacao,
                "P_NRPARCAVALIADO"  => $nrparcavaliado,
                "P_NRCOMBQUESTAVAL" => $nrcombquestaval,
                "P_NRORG"           => $nrorg
          )
        );
    }

    public function updateRespAvaliacao($resposta, $dsresposta, $nrorg, $nrrespavaliacao) {
        $query = $this->entityManager->getConnection()->prepare("
                UPDATE RESPAVALIACAO
                   SET NRRESPOSTA = :P_RESPOSTA, 
                   TXRESPAVALIACAO = :P_DSRESPOSTA
                 WHERE NRORG = :P_NRORG 
                 AND NRRESPAVALIACAO = :P_NRRESPAVALIACAO");

        return $query->execute(
          array(
              "P_RESPOSTA"        => $resposta,
              "P_DSRESPOSTA"      => $dsresposta,
              "P_NRRESPAVALIACAO" => $nrrespavaliacao,
              "P_NRORG"           => $nrorg
          )
        );
    }

    public function verificaExistenciaParticipaval($dataSet) {
        $query = $this->entityManager->getConnection()->prepare("
              SELECT COUNT(1) AS RESULT
                FROM PARTICIPAVAL
               WHERE NRAVALIACAO     = :P_NRAVALIACAO
                 AND NRPARCAVALIADO  = :P_NRPARCAVALIADO
                 AND NRPARCEXECAVAL  = :P_NRPARCEXECAVAL
                 AND NRTIPORELACIONA = :P_NRTIPORELACIONA
                 AND NRORG           = :P_NRORG"
        );
        $query->execute(
          array(
              "P_NRAVALIACAO"     => $dataSet['NRAVALIACAO'],
              "P_NRPARCAVALIADO"  => $dataSet['NRPARCAVALIADO'],
              "P_NRPARCEXECAVAL"  => $dataSet['NRPARCEXECAVAL'],
              "P_NRTIPORELACIONA" => $dataSet['NRTIPORELACIONA'],
              "P_NRORG"           => $dataSet['NRORG']
          )
        );
        return $query->fetchAll()[0];
    }

}

