-- ============================================================
-- Table: ESO_TPLOTATRIBUT
-- ============================================================
CREATE TABLE ESO_TPLOTATRIBUT
(
	NRORG 				NUMBER			NOT NULL,
	NRTPLOTATRIBUT		NUMBER			NOT NULL,
	DSTPLOTATRIBUT		VARCHAR2(700)	NOT NULL,
	CDTPINSCLOTTRI		VARCHAR2(50)	NULL,
	CDESOCIAL			VARCHAR2(2)		NOT NULL,
	IDATIVO				VARCHAR2(1)		DEFAULT 'S' NOT NULL
		CONSTRAINT CKC_IDATIVO_LOTTRIB CHECK (IDATIVO IN ('N','S')),
	DTINCLUSAO			DATE			DEFAULT SYSDATE NOT NULL,
	DTULTATU			DATE			NULL,
	NRORGINCLUSAO		NUMBER(22)		DEFAULT 1 NULL ,
	CDOPERINCLUSAO		VARCHAR2(12)	DEFAULT '1' NULL ,
	NRORGULTATU			NUMBER(22)		DEFAULT 1 NULL ,
	CDOPERULTATU		VARCHAR2(12)	DEFAULT '1' NULL ,
	CONSTRAINT PK_ESO_TPLOTATRIBUT PRIMARY KEY (NRTPLOTATRIBUT)
);

INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 1, '01', 'Classificação da atividade econômica exercida pela Pessoa Jurídica para fins de atribuição de código FPAS, inclusive obras de construção civil própria, exceto: a) empreitada parcial ou sub-empreitada de obra de construção civil (utilizar opção 02); b) prestação de serviços em instalações de terceiros (utilizar opções 03 a 09); c) Embarcação inscrita no Registro Especial Brasileiro - REB (utilizar opção 10).', NULL);
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 2, '02', 'Obra de Construção Civil - Empreitada Parcial ou Sub-empreitada', 'CNO');
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 3, '03', 'Pessoa Física Tomadora de Serviços prestados mediante cessão de mão de obra, exceto contratante de cooperativa', 'CPF');
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 4, '04', 'Pessoa Jurídica Tomadora de Serviços prestados mediante cessão de mão de obra, exceto contratante de cooperativa, nos termos da lei 8.212/1991', 'CNPJ');
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 5, '05', 'Pessoa Jurídica Tomadora de Serviços prestados por cooperados por intermédio de cooperativa de trabalho, exceto aqueles prestados a entidade beneficente/isenta', 'CNPJ');
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 6, '06', 'Entidade beneficente/isenta Tomadora de Serviços prestados por cooperados por intermédio de cooperativa de trabalho', 'CNPJ');
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 7, '07', 'Pessoa Física tomadora de Serviços prestados por Cooperados por intermédio de Cooperativa de Trabalho', 'CPF');
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 8, '08', 'Operador Portuário tomador de serviços de trabalhadores avulsos', 'CNPJ');
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 9, '09', 'Contratante de trabalhadores avulsos não portuários por intermédio de Sindicato', 'CNPJ, CPF');
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 10, '10', 'Embarcação inscrita no Registro Especial Brasileiro - REB', NULL);
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 11, '21', 'Classificação da atividade econômica ou obra própria de construção civil da Pessoa Física', NULL);
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 12, '24', 'Empregador Doméstico', NULL);
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 13, '90', 'Atividades desenvolvidas no exterior por trabalhador vinculado ao Regime Geral de Previdência Social (expatriados)', NULL);
INSERT INTO ESO_TPLOTATRIBUT (NRORG, NRTPLOTATRIBUT, CDESOCIAL, DSTPLOTATRIBUT, CDTPINSCLOTTRI) VALUES (0, 14, '91', 'Atividades desenvolvidas por trabalhador estrangeiro vinculado a Regime de Previdência Social Estrangeiro', NULL);

-- ============================================================
-- Table: TIPOESTRUTURA
-- ============================================================
ALTER TABLE TIPOESTRUTURA ADD NRTPLOTATRIBUT NUMBER;

CREATE INDEX FK_308980_FK ON TIPOESTRUTURA (NRTPLOTATRIBUT ASC);

ALTER TABLE TIPOESTRUTURA
	ADD CONSTRAINT FK_TIPOESTR_LOTTRIB FOREIGN KEY (NRTPLOTATRIBUT)
		REFERENCES ESO_TPLOTATRIBUT (NRTPLOTATRIBUT);