/*
      8380_SUPSTPO_DUPLICA_PRECO_OBJETIVO.SQL

      P_IDDUPLICA - Tipo de duplicao:
      1 - Planilha Corrente (posicionada na tela)
      2 - Planilhas com aquela validade
*/
CREATE OR REPLACE
PROCEDURE DUPLICA_PRECO_OBJETIVO
   ( P_CDFILIAL      IN FILIAL.CDFILIAL%TYPE,
     P_CDREGIAO      IN REGIAO.CDREGIAO%TYPE,
     P_NRPRECOBJET   IN PRECOBJETIVO.NRPRECOBJET%TYPE,
     P_IDDUPLICA     IN VARCHAR2,
     P_DTINIVALPLAN  IN PRECOBJETIVO.DTINIVALOBJET%TYPE,
     P_DTFINVALPLAN  IN PRECOBJETIVO.DTFINVALOBJET%TYPE,
     P_LISTAFILI     IN VARCHAR2,
     P_REAJUSTE      IN NUMBER,
     P_DTNOVINIVAL   IN PRECOBJETIVO.DTINIVALOBJET%TYPE,
     P_DTNOVFINVAL   IN PRECOBJETIVO.DTFINVALOBJET%TYPE
   )
IS
   V_CDFILIAL        FILIAL.CDFILIAL%TYPE;
   V_CDREGIAO        REGIAO.CDREGIAO%TYPE;

   V_NOVONRPRECOBJET VARCHAR2(20);
   V_NRPRECOBJETORIG PRECOBJETIVO.NRPRECOBJET%TYPE;
   V_CDFILIALORIG    FILIAL.CDFILIAL%TYPE;

   CURSOR C_FILIPLANPRECO IS
      SELECT CDFILIAL, CDREGIAO
        FROM FILIAL
       WHERE ((INSTR(P_LISTAFILI, CDFILIAL) > 0) OR (P_LISTAFILI = 'T'))
         AND CDREGIAO IS NOT NULL
       ORDER BY CDFILIAL;
BEGIN

   OPEN C_FILIPLANPRECO;
   LOOP
      FETCH C_FILIPLANPRECO INTO V_CDFILIAL, V_CDREGIAO;
      EXIT WHEN C_FILIPLANPRECO%NOTFOUND;

      NOVO_CODIGO('PRECOBJETIVO'||V_CDFILIAL, V_NOVONRPRECOBJET);
      V_NOVONRPRECOBJET := SUBSTR(V_NOVONRPRECOBJET,11,10);

      INSERT INTO PRECOBJETIVO
         (CDFILIAL,
          NRPRECOBJET,
          DTPRECOBJET,
          DTINIVALOBJET,
          DTFINVALOBJET)
      VALUES
         (V_CDFILIAL,
          V_NOVONRPRECOBJET,
          TO_DATE(SYSDATE, 'DD/MM/YYYY'),
          P_DTNOVINIVAL,
          P_DTNOVFINVAL);

      FOR C_PRECOJETIVO IN
         ( SELECT CDPRODUTO, ((MIN(VRPRECOBJETIVO)+(MIN(VRPRECOBJETIVO) * P_REAJUSTE) / 100)) VRPRECOBJETIVO
            FROM ITEMPRECOJETIVO
           WHERE ((P_IDDUPLICA = '1' AND NRPRECOBJET = P_NRPRECOBJET) OR
                  (P_IDDUPLICA = '2'  AND DTINIVALITMOBJ >= P_DTINIVALPLAN AND DTFINVALITMOBJ <= P_DTFINVALPLAN))
           GROUP BY CDPRODUTO
           ORDER BY VRPRECOBJETIVO
         )
      LOOP
        SELECT MAX(NRPRECOBJET), MAX(CDFILIAL)
          INTO V_NRPRECOBJETORIG, V_CDFILIALORIG
          FROM ITEMPRECOJETIVO
         WHERE CDPRODUTO = C_PRECOJETIVO.CDPRODUTO
           AND VRPRECOBJETIVO = ((C_PRECOJETIVO.VRPRECOBJETIVO * 100) / (100 + P_REAJUSTE));

         INSERT INTO ITEMPRECOJETIVO
            (CDFILIAL,
             NRPRECOBJET,
             CDREGIAO,
             CDPRODUTO,
             DTINIVALITMOBJ,
             DTFINVALITMOBJ,
             VRPRECOBJETIVO,
             NRPRECOBJETORIG,
             CDFILIALORIG)
         VALUES
            (V_CDFILIAL,
             V_NOVONRPRECOBJET,
             V_CDREGIAO,
             C_PRECOJETIVO.CDPRODUTO,
             P_DTNOVINIVAL,
             P_DTNOVFINVAL,
             C_PRECOJETIVO.VRPRECOBJETIVO,
             V_NRPRECOBJETORIG,
             V_CDFILIALORIG);
      END LOOP;
      COMMIT;
   END LOOP;
   CLOSE C_FILIPLANPRECO;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('DUPLICA_COTACAO','5.60.XXX'); END;
/
